%The below finds where we have a change from barren to ice
%covered and if there was an ice-covered neighbor before the change, assign that thermal profile
%to the new ice covered node... determining which direction the advance is coming from...
%it also allows for a multiple-node advance... assigning all new ice-covered nodes the thermal
%profile from the nearest ice-covered neighbor before the change or the average of the nearest
%two ice-covered neighbors in the case of merging ice sheets.  NOTE:  approx will be ave of
%two previously existing ice covered nodes over the entire zone of newly covered nodes
%regardless of the distance of the advance from each ice front.  (nonphysical, but good
%enough b/c the entire idea of merging ice is nonphysical without longitundinal stress)  

location=find( (ref_barren(1:2:nods*2)==1) & (barren(1:2:nods*2)==0) );
locationcount=size(location)*[1 0]';

multinode=zeros(locationcount,1);
contnode=multinode;

if locationcount>1
	for n=2:locationcount-1
		multinode(n)=(location(n)==(location(n+1)-1)) | (location(n)==(location(n-1)+1));
		contnode(n)=multinode(n) & ~((location(n)==(location(n+1)-1)) & (location(n)==(location(n-1)+1)));
	end
	multinode(1)=location(1)==location(2)-1;
	multinode(locationcount)=(location(locationcount)==location(locationcount-1)+1);
	contnode(1)=multinode(1);
	contnode(locationcount)=multinode(locationcount);

	locator=find(multinode & contnode);
	locator2=size(locator)*[1 0]'/2;   %used to pair the endpts in locator of a continuous advance over multiple nodes

	indexloc=zeros(locator2,2);

	for n=1:locator2
 		indexloc(n,:)=[n*2-1 n*2];
	end
end

for n=1:locationcount
   	if multinode(n)    %this statement accounts for multiple node advances or multiple node ice growth from barren ground
		j=0;
		jj=0;
		jjj=0; 
		if (  ( (location(1)~=1) | (location(1)==1 & ~multinode(1))) ...
			& ( (location(locationcount)~=nods) | (location(locationcount)==nods & ~multinode(locationcount)) )   )
			for i=1:locator2
				if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==1) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	%assign T of nearest old ice covered node on right
				    		j=j+1;
				elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==1) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	%assign T of nearest old ice covered node on left
                   			jj=jj+1;
				elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
				    		T(location(n),rocklev+1:nlev)=(T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev) ...
							+ T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev))/2; %assign ave T of nearest old ice covered nodes on right and left	
                   			jjj=jjj+1;
				end
			end
		elseif ( (location(1)==1) & ((location(locationcount)~=nods) ... 
			| (location(locationcount)==nods & ~multinode(locationcount))) )
			for i=1:locator2
				if i==1
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	
				   			j=j+1;
					end
                elseif i~=1				
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==1) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	
				    		j=j+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==1) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	
                   			jj=jj+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
				    		T(location(n),rocklev+1:nlev)=(T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev) ...
							+ T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev))/2;	
                   			jjj=jjj+1;
					end
				end
			end
		elseif (  ( (location(1)~=1) | (location(1)==1 & ~multinode(1)) ) & location(locationcount)==nods)  
			for i=1:locator2
				if i==locator2
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	
                   			jj=jj+1;
					end
                elseif i~=locator2				
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==1) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	
				    		j=j+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==1) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	
                   			jj=jj+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
				    		T(location(n),rocklev+1:nlev)=(T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev) ...
							+ T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev))/2;	
                   			jjj=jjj+1;
					end
				end
			end		
		elseif (location(1)==1 & (location(locationcount)==nods))
			for i=1:locator2
				if i==1
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	
				   			j=j+1;
					end
                elseif i~=1 & i~=locator2				
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==1) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
					    	T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev);	
				    		j=j+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==1) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	
                   			jj=jj+1;
					elseif ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) ...
						& (barren(location(locator(indexloc(i,2)))*2+1)==0) )
				    		T(location(n),rocklev+1:nlev)=(T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev) ...
							+ T(location(locator(indexloc(i,2)))+1,rocklev+1:nlev))/2;	
                   			jjj=jjj+1;
					end
				elseif i==locator2		
					if ( (location(locator(indexloc(i,1)))<=location(n)) ...
						& (location(n)<=location(locator(indexloc(i,2)))) ...
						& (barren(location(locator(indexloc(i,1)))*2-3)==0) )
				    		T(location(n),rocklev+1:nlev)=T(location(locator(indexloc(i,1)))-1,rocklev+1:nlev);	
                   			jj=jj+1;
					end
				end
			end		
		end
		if j+jj+jjj==0
			T(location(n),rocklev+1:nlev)=Tsurface(location(n)).*ones(1,nlev-rocklev); % use atmospheric temperature in "instant case"
		end				
	elseif ((location(n)>1 & location(n)<nods & ref_barren(location(n)*2-3)==0 & ref_barren(location(n)*2+1)==1) ...
	   	| (location(n)==nods & ref_barren(location(n)*2-3)==0))
	   	T(location(n),rocklev+1:nlev)=T(location(n)-1,rocklev+1:nlev); % use the upstream's T-profile when ice encroaches from left
   	elseif ((location(n)>1 & location(n)<nods & ref_barren(location(n)*2-3)==1 & ref_barren(location(n)*2+1)==0) ...
	   	| (location(n)==1 & ref_barren(location(n)*2+1)==0))
	   	T(location(n),rocklev+1:nlev)=T(location(n)+1,rocklev+1:nlev); % use the upstream's T-profile when ice encroaches from right
   	elseif (location(n)>1 & location(n)<nods & ref_barren(location(n)*2-3)==0 & ref_barren(location(n)*2+1)==0)
	    T(location(n),rocklev+1:nlev)=(T(location(n)-1,rocklev+1:nlev)+T(location(n)+1,rocklev+1:nlev))/2; % use the upstream's T-profile when ice encroaches from right and left	
	else
    	T(location(n),rocklev+1:nlev)=Tsurface(location(n)).*ones(1,nlev-rocklev); % use atmospheric temperature in "instant case"			
    end
end
