% Startup loading of data

s=FEMify*surfaceelev;
b=FEMify*bedrockelev;
thick=s-b;

barren(1:2:nods*2-1)=(thick(1:2:nods*2-1)<=0);
barren(4:2:nods*2-2)=( barren(1:2:nods*2-5) & barren(5:2:nods*2-1) );
barren(2)=barren(3);
barren(nods*2)=barren(nods*2-3);
barren(2:2:nods*2)=barren(2:2:nods*2).*barren(1:2:nods*2-1); %added to take care of 3-noded island of ice... 1,0  0,1  1,0 would result when want 1,0 0,0 1,0

snow=zeros(2*nods,1);
soup=zeros(2*nods,1);  %Why initializing snow to value in prelimpsu but not initializing soup to prelimpsu value?


% Is a particular node floating?  Used in isostasy calculations below...
si=(rho_seawater-rho)/rho_seawater * thick;
mfloat=((si(1:2:nods*2)>s(1:2:nods*2)) & (~barren(1:2:nods*2)));

%%********  USE THE FOLLOWING CODE FOR ELASTIC LITHOSPHERE, RELAXATION ASTHENOSPHERE *****
%% Elastic Lithosphere, Relaxation Asthenosphere treatment... finding isostatic equilibrium
%% initial position assuming present bed elevation is in isostatic equilibrium
%% with ice load: bnot is for removing ice and ignoring/removing water (air-filled ocean where
%% barren and below SL) --> bnot=b+lith_deflection
%
%%  ********* ice and seawater exist ***********
grav_load= (rho*thick(1:2:nods*2)).*(~mfloat) ...
  - (rho_seawater*bedrockelev).*(mfloat) ...
  - (rho_seawater*bedrockelev.*(bedrockelev<=0 & barren(1:2:nods*2))) ; 

grav_load=FEMify*grav_load;
  
A=sparse(rowperm,colperm,Dr*Ggauss,nods*2,nods*2);
%R=rho*g*Aperm*thick;  %used for "air-filled" ocean
R=g*Aperm*grav_load;   %used to take into acount "ocean-water-filled" ocean
Aprime=PLI*(rhoasth*g*Aperm+A)*PLI';

%%***The below is to assign non-zero deflection values at endpts of boundary domain
deflect_spec=zeros(nods*2,1);
deflect_spec(1)=grav_load(1)/rhoasth;   % If we wanted to specify deflection as nonzero at west end
deflect_spec(nods*2-1)=grav_load(nods*2-1)/rhoasth;  % If we wanted to specify deflection as nonzero at east end
deflect_spec=deflect_spec.*(~mls);

Rprime=PLI*(R-(rhoasth*g*Aperm+A)*deflect_spec); %For divides (fixed zero slope) and non-zero thickness boundary conditions (works for zero-valued cases also)
lith_prime=Aprime\Rprime;
lith_deflection=PLI'*lith_prime + deflect_spec;  % Note: look out for divides.  Putting known BCs back into soln.
%****

bed_iso_adjusted=bedrockelev+lith_deflection(1:2:nods*2);
bnot=FEMify*bed_iso_adjusted;

%********  END ELASTIC LITHOSPHERE, RELAXATION ASTHENOSPHERE ****************************

