% Mass balance for Snow:  
nactive=sum(ms);	
PDI=sparse([1:nactive]',find(ms==1)',ones(nactive,1),nactive,nods*2);


u_surface=FEMify*u_total(:,icelev);  


A=-sparse(rowperm,colperm,spdiags(expand_by_4*(u_surface(index2(:,1))),0,nel*4,nel*4)*D1gauss,nods*2,nods*2) ...
-sparse(rowperm,colperm,spdiags(expand_by_4*(u_surface(index2(:,2))),0,nel*4,nel*4)*D2gauss,nods*2,nods*2) ...
-sparse(rowperm,colperm,spdiags(expand_by_4*(u_surface(index2(:,3))),0,nel*4,nel*4)*D3gauss,nods*2,nods*2) ...
-sparse(rowperm,colperm,spdiags(expand_by_4*(u_surface(index2(:,4))),0,nel*4,nel*4)*D4gauss,nods*2,nods*2) ...
+ sparse(rowperm,colperm,spdiags(expand_by_4*(Le.*abs(udefbar(:,icelev)+uslidebar(:))/2),0,nel*4,nel*4)*Bgauss,nods*2,nods*2); % artificial diffusion



%**	create right-hand side matrix

R=Aperm*(snow/dtmass + Sdot);  %no need to subtract knowns from RHS b/c zero-valued
Rprime=PDI*R;  	% snow thickness assumed zero at all points masked by PDI			
Aprime=PDI*(Aperm/dtmass+A)*PDI'; 
snowprime=Aprime\Rprime;
snowtentative=PDI'*snowprime;  %since known BCs are zero-valued, no need to add more to this step of putting knowns back into soln


clear Rprime Aprime PDI 


%Taking a timestep and checking if no snow or snow, then set BCs and 
%take timestep over again w/zero thickness where no snow... otherwise 
%it will allow for negative thickness where no snow exists
%which will lead to ill-conditioned matrices.
nosnowold=zeros(2*nods,1);
nosnow(1:2:nods*2-1)=(snowtentative(1:2:nods*2-1)<=0);
nosnow(4:2:nods*2-2)=( nosnow(1:2:nods*2-5) & nosnow(5:2:nods*2-1) );
nosnow(2)=nosnow(3);
nosnow(nods*2)=nosnow(nods*2-3);
nosnow(2:2:nods*2)=nosnow(2:2:nods*2).*nosnow(1:2:nods*2-1);  %added to take care of 3-noded island of snow... 1,0 0,1 1,0 would result when want 1,0 0,0 1,0


while ( (sum(abs(nosnow-nosnowold))~=0) & (sum(~nosnow)>0) )  %test when nosnow doesn't change anymore and avoid problems in case when all snow is gone.

nactive=sum(ms & ~nosnow);	
PDI=sparse([1:nactive]',find(ms & ~nosnow)',ones(nactive,1),nactive,nods*2);

Rprime=PDI*R;  				%no need to add zero-valued BCs
Aprime=PDI*(Aperm/dtmass+A)*PDI';	
snowprime=Aprime\Rprime;              %Solve for tentative snow-layer thickness 
snowtentative=PDI'*snowprime;         %putting zero-valued BCs back into soln
nosnowold=nosnow;
nosnow(1:2:nods*2-1)=(snowtentative(1:2:nods*2-1)<=0);
nosnow(4:2:nods*2-2)=( nosnow(1:2:nods*2-5) & nosnow(5:2:nods*2-1) );
nosnow(2)=nosnow(3);
nosnow(nods*2)=nosnow(nods*2-3);
nosnow(2:2:nods*2)=nosnow(2:2:nods*2).*nosnow(1:2:nods*2-1);  %added to take care of 3-noded island of snow... 1,0 0,1 1,0 would result when want 1,0 0,0 1,0

clear Rprime Aprime PDI 
end
snow=snowtentative.*(~nosnow);

snow=snow.*(snow<=firnlayer)+firnlayer.*(snow>firnlayer);   

clear Rprime Aprime PDI zthickprime value row count gauss m k j