% Mass balance for soup: 

nactive=sum(ms);	
PDI=sparse([1:nactive]',find(ms==1)',ones(nactive,1),nactive,nods*2);


%**	create right-hand side matrix

R=Aperm*(soup/dtmass + soupdot);   %no need to subtract knowns from RHS b/c zero-valued

Rprime=PDI*R;  	% soup thickness assumed zero at all points masked by PDI			

Aprime=PDI*(Aperm/dtmass+A)*PDI';	

soupprime=Aprime\Rprime;

souptentative=PDI'*soupprime;    %since known BCs are zero-valued, no need to add more to this step of putting knowns back into soln

%Taking a timestep and checking if no soup or soup, then set BCs and 
%take timestep over again w/zero thickness where no soup... otherwise 
%it will allow for negative thickness where no soup exists
%which will lead to ill-conditioned matrices.
nosoupold=zeros(2*nods,1);
nosoup(1:2:nods*2-1)=(souptentative(1:2:nods*2-1)<=0);
nosoup(4:2:nods*2-2)=( nosoup(1:2:nods*2-5) & nosoup(5:2:nods*2-1) );
nosoup(2)=nosoup(3);
nosoup(nods*2)=nosoup(nods*2-3);
nosoup(2:2:nods*2)=nosoup(2:2:nods*2).*nosoup(1:2:nods*2-1);  %added to take care of 3-noded island of soup... 1,0 0,1 1,0 would result when want 1,0 0,0 1,0


while ( (sum(abs(nosoup-nosoupold))~=0) & (sum(~nosoup)>0) )   %test when nosoup doesn't change anymore and avoid problems in case when all soup is gone.

nactive=sum(ms & ~nosoup);   
PDI=sparse([1:nactive]',find(ms & ~nosoup)',ones(nactive,1),nactive,nods*2);

Rprime=PDI*R;  			%no need to add zero-valued BCs	
Aprime=PDI*(Aperm/dtmass+A)*PDI';	
soupprime=Aprime\Rprime;        %Solve for tentative soup-layer thickness
souptentative=PDI'*soupprime;   %putting zero-valued BCs back into soln
nosoupold=nosoup;
nosoup(1:2:nods*2-1)=(souptentative(1:2:nods*2-1)<=0);
nosoup(4:2:nods*2-2)=( nosoup(1:2:nods*2-5) & nosoup(5:2:nods*2-1) );
nosoup(2)=nosoup(3);
nosoup(nods*2)=nosoup(nods*2-3);
nosoup(2:2:nods*2)=nosoup(2:2:nods*2).*nosoup(1:2:nods*2-1);  %added to take care of 3-noded island of soup... 1,0 0,1 1,0 would result when want 1,0 0,0 1,0
end
soup=souptentative.*(~nosoup);

soup=soup.*(soup<=souplayer)+souplayer.*(soup>souplayer);  

clear Rprime Aprime PDI zthickprime value row count gauss m k j
